﻿#Region "FileHeader"
#If False Then
Konvertiert Doubles (Stunden) zu Strings im "h:mm"-Format und zurück. Dadurch kann im Dataset statt Timespan Double genommen werden, was Arithmetik in berechneten Spalten besser unterstützt
Man kann datengebundene Datagridviews und Textboxen darauf registrieren, dann verhalten die sich entsprechend
#End If '-- Options, Imports
#End Region 'FileHeader

Namespace System.Windows.Forms
   Public Class TimeDoubleBehavior

      Private Shared ReadOnly _KnownKeys As New Runtime.CompilerServices.ConditionalWeakTable(Of Object, Object)

      ''' <summary>Exception when any TextBinding either Null or already registered </summary>
      Public Shared Sub RegisterTextboxes(ParamArray textboxes As TextBoxBase())
         For Each tB In textboxes
            Dim bnd = tB.DataBindings("Text")
            Dim x = New TimeDoubleTextboxBehavior(bnd)
            _KnownKeys.Add(bnd, Nothing)
         Next
      End Sub

      ''' <summary>Exception when dgv already registered </summary>
      Public Shared Sub RegisterDgv(dgv As DataGridView, timeDoubleDataColumns As IEnumerable(Of DataColumn))
         Dim x = New TimeDoubleDgvBehavior(dgv, timeDoubleDataColumns)
         _KnownKeys.Add(dgv, Nothing)
      End Sub

      ''' <summary> liest aus sTime stunden und minuten, returnt die gesamt-stunden - bei ungültiger Eingabe 0.0. Minutentrenner sind beliebige Nicht-Ziffern, können sogar auch weggelassen werden </summary>
      Public Shared Function TimeString2Double(sTime As String) As Double
         If sTime.Length = 0 Then Return 0.0
         Dim chars = sTime.ToCharArray()
         Dim len = 3.Min(chars.Length)
         Dim isNegative = chars(0) = "-"c
         'in den letzten 3 chars rückwärts nach einem Separator suchen
         Dim iSep = Array.FindLastIndex(chars, chars.Length - 1, len, Function(c) Not Char.IsDigit(c))
         If isNegative AndAlso iSep = 0 Then iSep = -1 ' ggfs. das Minus am Anfang ist natürlich kein Separator
         Dim minutes = 0.0
         'Der Select liest (evtl.) die Minuten, und stellt dann iSep so ein, dass anschl. die Stunden gelesen wern können
         Select Case iSep
            Case Is < 0, chars.Length ' kein Separator gefunden
               chars = chars.Where(AddressOf Char.IsDigit).ToArray ' chars bereinigen von non-Digits
               If chars.Length < 3 Then iSep = chars.Length : Exit Select ' keine Minuten (nur s.u. Stunden)
               'bei mehr als 2 ziffern die letzten beiden als Minute lesen
               len.Minimize(2)
               iSep = chars.Length - len
               minutes = Double.Parse(New String(chars, iSep, len))
            Case Else
               iSep += 1
               len = chars.Length - iSep
               If len > 0 Then minutes = Double.Parse(New String(chars, iSep, len)) ' ab iSep Minuten lesen
               chars = chars.Take(iSep - 1).Where(AddressOf Char.IsDigit).ToArray ' nur chars bis iSep übriglassen
               iSep = chars.Length
         End Select
         'bis iSep als Stunden lesen
         Dim dbl = If(iSep = 0, 0, Double.Parse(New String(chars, 0, iSep))) + minutes / 60
         Return If(isNegative, -dbl, dbl)
      End Function

      ''' <summary> stellt dblHours im "h:mm"-Format dar </summary>
      Public Shared Function Double2TimeString(dblHours As Double) As String
         Dim isNegative = dblHours < 0
         If isNegative Then dblHours = -dblHours
         Dim rest = 0
         Dim value = Math.DivRem(CInt(dblHours * 60), 60, rest)
         Dim s = String.Format("{0}:{1:00}", value, rest)
         Return If(isNegative, "-" & s, s)
      End Function

   End Class


End Namespace